import React, {useState, useEffect, useRef} from 'react';
import Link from '@mui/material/Link';
import List from '@mui/material/List';
import ListItem from '@mui/material/ListItem';
import ListItemText from '@mui/material/ListItemText';
import ListItemAvatar from '@mui/material/ListItemAvatar';
import Box from '@mui/material/Box';

import {FloatBtn, ChatAvatar} from "../components"
import {connect}  from 'react-redux'
import {
  actionFullChatList
} from "../actions"
 
const Chat = ({chat}) => {

  let {_id, title, owner, members} = chat

  return (
    <Link href={`/main/${_id}`}>
      <ListItem >
        <ListItemAvatar>
          <ChatAvatar chat={chat} />
        </ListItemAvatar>
        <ListItemText primary={title} secondary={'затычка'} />
      </ListItem>
    </Link>
  )
}


const ChatList = ({chats, userId, getData}) => {
  const [chatBlock, setChatBlock] = useState(0)

  useEffect(() => {
    getData(userId, chatBlock, 20)
  },[])

  return (
    <List sx={{ width: '100%', bgcolor: 'background.paper', position: 'relative', zIndex: 2 }}>
      <Box sx={{  position: 'fixed', top: '90%', left: '25%', zIndex: 10}} >
        <FloatBtn />
      </Box>
      {chats.map(chat => <Chat key={chat._id} chat={chat}/>)}  
    
    </List>
  )
}
export const CChatList = connect( state => ({ chats: Object.values(state.chats) || [],
                                              userId: state.auth.payload.sub.id || null}),
                                  {getData: actionFullChatList}
                                  )(ChatList)


