
import { printStrReq } from '.'

export const passReq = {

   minPass:'2', 
   char:false, 
   bigChar:false, 
   number:false,

   checkPass(password) {
      if (  password.length >= this.minPass && 
            !password.match(/\s/) && 
            (this.char ? password.match(/[a-zа-яё]/) : true) && 
            (this.bigChar ? password.match(/[A-ZА-ЯЁ]/) : true) && 
            (this.number ? password.match(/[\d]/) : true) ) {
      return true
      } else {
         return false
      }
   },
   
   printPassReq(password) {
      let str = ''
      if (this.checkPass(password)) {
         str += 'Пароль подходит '
      } else if (password.match(/\s/)) {
         str += 'Пароль не должен содержать пробелы '
      } else {
         str += 'Пароль должен содержать: '
         str += printStrReq(password, this.minPass) + ','
         if (!(this.char ? password.match(/[a-zа-яё]/) : true)) {
            str += ' строчные буквы,'
         }
         if (!(this.bigChar ? password.match(/[A-ZА-ЯЁ]/) : true)) {
            str += ' прописные буквы,'
         }
         if  (!(this.number ? password.match(/[\d]/) : true)) {
            str += ' цифры,'
         }
      }
      return str.slice(0, -1)
   }

}

