import React, {useState, useEffect, useRef} from 'react';
import {Router, Route, Redirect, Switch} from 'react-router-dom'

import Button from '@mui/material/Button';
import Typography from '@mui/material/Typography';
import Link from '@mui/material/Link';
import CssBaseline from '@mui/material/CssBaseline';
import Grid from '@mui/material/Grid';
import Box from '@mui/material/Box';
import Container from '@mui/material/Container';
import { createTheme, ThemeProvider } from '@mui/material/styles';



import {
   MenuDrawer, 
   SearchBlock, 
   CChatList, 
   Header, 
   CUserAvatar, 
   CSendingField
} from "../components"
import {
   actionChangePass,
   actionAddChat
 } from "../actions"
 import {store} from "../reducers"


 const Page404 = () => (
   <h1>Тут ведутся работы</h1>
   )

const theme = createTheme()
export const Main = ({}) => {

   return (
      <ThemeProvider theme={theme}>
         <Container component="main" maxWidth="xxl">
            <CssBaseline />

            <Grid container direction="row" justifyContent="center" alignItems="start" >

               <Grid item xs={12} sm={4}>
                  <Grid container direction="column" justifyContent="space-between" alignItems="stretch" 
                        height="100vh">

                     <Grid item height="60px"> 
                        <Header> 

                           <MenuDrawer />
                           <CUserAvatar />

                           <SearchBlock />

                        </Header>                        
                     </Grid>

                     <Grid container direction="column" justifyContent="start" alignItems="stretch" 
                           height="calc(100vh - 60px)" sx={{overflowY:"scroll"}}>
                        
                        <CChatList />

                     </Grid>

                  </Grid>              
               </Grid>

               <Grid item xs={12} sm={8}>
                  <Grid container direction="column" justifyContent="space-between" alignItems="stretch" 
                        height="100vh" sx={{backgroundColor: '#eee'}} >
                     
                     
                     <Grid item height="60px"> 
                        <Header> 
                           <Typography variant="body1" color="inherit" component="div">
                              шапка2: инфо о чате и управление, управление сообщениями, ?поиск
                           </Typography>
                        </Header>                    
                     </Grid>

                     <Grid item sx={{ flexGrow: 1 }} >


                           
             {/*            <Switch> 
                           <Route path="/main/:_id" component={} />
                           <Route path="*" component={} /> 
                        </Switch> */}

                     </Grid>

                     <Grid item  sx={{ flexGrow: 0 }} height="max-content" > 
                           <CSendingField />
                     </Grid>

                  </Grid>              
               </Grid>

            </Grid>

         </Container>
      </ThemeProvider>
   )
}