import { createStore, combineReducers, applyMiddleware } from 'redux'
import thunk from 'redux-thunk'
import { promiseReducer } from './promiseReducer'
import { authReducer } from './authReducer'
import { chatsReducer } from './chatsReducer'
import { localStoredReducer } from './localStoredReducer'

import { actionAboutMe } from './findUserActions'
import { 
   actionMsgOne, 
   actionChatOne, 
   actionChatLeft 
} from './chatsReducer'

// const { io } = require("socket.io-client");

export const store =  createStore (  combineReducers({ 
                                    // promise: localStoredReducer(promiseReducer, 'promise'),
                                    // auth: localStoredReducer(authReducer, 'auth'),
                                    // chats: localStoredReducer(chatsReducer, 'chats'),
                                    promise: promiseReducer, 
                                    auth: authReducer, 
                                    chats: chatsReducer
                                                }),
                                    applyMiddleware(thunk)
                        )

store.dispatch(actionAboutMe())

store.subscribe(() => console.log(store.getState()))


// const socket = io("ws://chat.fs.a-level.com.ua")

// if (localStorage.authToken) {
//    socket.emit('jwt', localStorage.authToken)
// } 

// socket.on('jwt_ok',   (data) => console.log(data))
// socket.on('jwt_fail', (error) => console.log(error))

// socket.on('msg', (msg) => { 
//     store.dispatch(actionMsgOne(msg)) 
// })
// socket.on('chat', (chat) => { 
//     store.dispatch(actionChatOne(chat)) 
// })
// socket.on('chat_left', (chat) => { 
//     store.dispatch(actionChatLeft(chat)) 
// })


// combineReducers({cart: localStoredReducer(cartReducer, 'cart'),
//                  promise: localStoredReducer(promiseReducer, 'promise') })
//для пользы при работе с промисами надо бы пока PENDING не делать payload undefined 
//при наличии старого payload 
//http://gitlab.a-level.com.ua/gitgod/react-template/src/nosaga/src/reducers/index.js#L13